import es, popuplib, playerlib, cmdlib, langlib

es.ServerVar("es_round_message").set(1)
es.ServerVar("es_sound_send").set("send.wav")
filter_function = {}
sound = None

def load():
	es.flags("add", "notify", "es_round_message")
	global cash_menu
	global translate_function
	global player
	translate_function = langlib.Strings(es.getAddonPath("cash_need") + "/cash_need_phrases.ini")
	if not es.exists("saycommand", "!cash"):
		cmdlib.registerSayCommand("!cash", cash_function, "Send players some cash")
	cash_menu = popuplib.construct("Cash Player", "players", "#alive", menu_select)
	es.addons.registerSayFilter(CashCount)

def es_map_load(ev):
	global sound
	sound = es.getString("es_sound_send")
	if sound: es.stringtable("downloadables", "sounds/player/" + es.getString("es_sound_send"))
	
def unload():
	if popuplib.exists("Cash Player"):
		popuplib.unsendname("Cash Player", playerlib.getPlayerList("#alive"))
		popuplib.delete("Cash Player")
	cmdlib.unregisterSayCommand("!cash")
	es.addons.unregisterSayFilter(CashCount)
	filter_function.clear()
	es.flags("remove", "notify", "es_round_message")

def cash_function(userid, args):
	player = playerlib.getPlayer(userid)
	if int(userid) != 0:
		if not len(args):
			if not player.isdead:
				if not popuplib.isqueued("Cash Player", userid):
					cash_menu.settitle(translate_function("Menu Title", {}, player.getLanguage()))
					popuplib.send("Cash Player", userid)
				else: tell(userid, translate_function("Menu Opened", {}, player.getLanguage()))
			else: tell(userid, translate_function("Menu Death", {}, player.getLanguage()))
		else : tell(userid, translate_function("Menu Usage", {}, player.getLanguage()))

def menu_select(userid, choice, menu_name):
	player = playerlib.getPlayer(userid)
	es.cexec(userid, "play buttons/button14.wav")
	if es.exists("userid", choice):
		if not playerlib.getPlayer(choice).isdead:
			if userid != choice:
				filter_function[userid] = {"userid_choice" : choice, "name_choice" : es.getplayername(choice)}
				tell(userid, translate_function("Cash Amount", {"name" : es.getplayername(filter_function[userid]["userid_choice"])}, player.getLanguage()))
			else:
				tell(userid, translate_function("Sent HimSelf", {}, player.getLanguage()))
				popuplib.send("Cash Player", userid)
		else:
			tell(userid, translate_function("Player Death", {"name" : player.name}, player.getLanguage()))
			popuplib.send("Cash Player", userid)
	else: popuplib.send("Cash Player", userid)

def round_start(ev):
	if es.getInt("es_round_message"):
		for userid in playerlib.getPlayerList("#human,#alive"):
			tell(userid, translate_function("Round Message", {}, playerlib.getPlayer(userid).getLanguage()))

def CashCount(userid, text, teamonly):
	if not userid in filter_function:
		return(userid, text, teamonly)
	try: player_choice = playerlib.getPlayer(filter_function[userid]["userid_choice"])
	except playerlib.UseridError:
		tell(userid, translate_function("Player Disconnect", {"name" : filter_function[userid]["name_choice"]} , playerlib.getPlayer(userid).getLanguage()))
		del(filter_function[userid])
		return(False, False, False)
	try: text = int(text.strip('"'))
	except ValueError:
		del(filter_function[userid])
		tell(userid, translate_function("Incorrect Integer", {}, playerlib.getPlayer(userid).getLanguage()))
		return(False, False, False)
	if text <= 0:
		del(filter_function[userid])
		tell(userid, translate_function("Incorrect Integer", {}, playerlib.getPlayer(userid).getLanguage()))
		return(False, False, False)
	player_send = playerlib.getPlayer(userid)
	if player_send.getCash() < text:
		del(filter_function[userid])
		tell(userid, translate_function("Cash Enought", {}, player_send.getLanguage()))
		return(False, False, False)
	player_choice.cash += text
	player_send.cash -= text
	global sound
	if sound: es.cexec(player_send, "play player/" + sound)
	tell(userid, translate_function("Player Send", {"cash" : text, "name" : player_choice.name}, player_send.getLanguage()))
	if not es.isbot(player_choice):
		tell(player_choice, translate_function("Player Get", {"cash" : text, "name" : player_send.name}, player_choice.getLanguage()))
		if sound: es.cexec(player_choice, "play player/" + sound)
	del(filter_function[userid])
	return(False, False, False)

def tell(userid, text):
	es.tell(userid, "#multi", "#green[Player Cash]#default %s"%(text))